- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# osg::CullingSet Class Reference

A CullingSet class which contains a frustum and a list of occluders. More...

Inheritance diagram for osg::CullingSet:

[legend]
List of all members.

## Public Types
typedef std::vector< ShadowVolumeOccluder > | OccluderList
typedef unsigned int | Mask
enum | MaskValues { NO_CULLING = 0x0, VIEW_FRUSTUM_SIDES_CULLING = 0x1, NEAR_PLANE_CULLING = 0x2, FAR_PLANE_CULLING = 0x4, VIEW_FRUSTUM_CULLING, SMALL_FEATURE_CULLING = 0x8, SHADOW_OCCLUSION_CULLING = 0x10, DEFAULT_CULLING, ENABLE_ALL_CULLING }
## Public Member Functions
| CullingSet ()
| CullingSet (const CullingSet &cs)
| CullingSet (const CullingSet &cs, const Matrix &matrix, const Vec4 &pixelSizeVector)
CullingSet & | operator= (const CullingSet &cs)
void | set (const CullingSet &cs)
void | set (const CullingSet &cs, const Matrix &matrix, const Vec4 &pixelSizeVector)
void | setCullingMask (Mask mask)
void | setFrustum (Polytope &cv)
Polytope & | getFrustum ()
const Polytope & | getFrustum () const
void | addOccluder (ShadowVolumeOccluder &cv)
void | setPixelSizeVector (const Vec4 &v)
Vec4 & | getPixelSizeVector ()
const Vec4 & | getPixelSizeVector () const
void | setSmallFeatureCullingPixelSize (float value)
float & | getSmallFeatureCullingPixelSize ()
float | getSmallFeatureCullingPixelSize () const
float | pixelSize (const Vec3 &v, float radius) const
| Compute the pixel of an object at position v, with specified radius.
float | pixelSize (const BoundingSphere &bs) const
| Compute the pixel of a bounding sphere.
bool | isCulled (const std::vector< Vec3 > &vertices)
bool | isCulled (const BoundingBox &bb)
bool | isCulled (const BoundingSphere &bs)
void | pushCurrentMask ()
void | popCurrentMask ()
void | disableAndPushOccludersCurrentMask (NodePath &nodePath)
void | popOccludersCurrentMask (NodePath &nodePath)
virtual | ~CullingSet ()
## Protected Attributes
Mask | _mask
Polytope | _frustum
OccluderList | _occluderList
Vec4 | _pixelSizeVector
float | _smallFeatureCullingPixelSize

## Detailed Description

A CullingSet class which contains a frustum and a list of occluders.

## Member Typedef Documentation

typedef unsigned int osg::CullingSet::Mask

typedef std::vector<ShadowVolumeOccluder> osg::CullingSet::OccluderList

## Member Enumeration Documentation

enum osg::CullingSet::MaskValues

  | Enumerator:
  NO_CULLING |
  VIEW_FRUSTUM_SIDES_CULLING |
  NEAR_PLANE_CULLING |
  FAR_PLANE_CULLING |
  VIEW_FRUSTUM_CULLING |
  SMALL_FEATURE_CULLING |
  SHADOW_OCCLUSION_CULLING |
  DEFAULT_CULLING |
  ENABLE_ALL_CULLING |

## Constructor & Destructor Documentation

CullingSet::CullingSet | ( |  | ) |

osg::CullingSet::CullingSet | ( | const CullingSet & | cs | ) | `[inline]`

osg::CullingSet::CullingSet | ( | const CullingSet & | cs,
|  | const Matrix & | matrix,
|  | const Vec4 & | pixelSizeVector
| ) | `[inline]`

CullingSet::~CullingSet | ( |  | ) | `[virtual]`

## Member Function Documentation

void osg::CullingSet::addOccluder | ( | ShadowVolumeOccluder & | cv | ) | `[inline]`

void CullingSet::disableAndPushOccludersCurrentMask | ( | NodePath & | nodePath | ) |

const Polytope& osg::CullingSet::getFrustum | ( |  | ) | const`[inline]`

Polytope& osg::CullingSet::getFrustum | ( |  | ) | `[inline]`

const Vec4& osg::CullingSet::getPixelSizeVector | ( |  | ) | const`[inline]`

Vec4& osg::CullingSet::getPixelSizeVector | ( |  | ) | `[inline]`

float osg::CullingSet::getSmallFeatureCullingPixelSize | ( |  | ) | const`[inline]`

float& osg::CullingSet::getSmallFeatureCullingPixelSize | ( |  | ) | `[inline]`

bool osg::CullingSet::isCulled | ( | const BoundingSphere & | bs | ) | `[inline]`

bool osg::CullingSet::isCulled | ( | const BoundingBox & | bb | ) | `[inline]`

bool osg::CullingSet::isCulled | ( | const std::vector< Vec3 > & | vertices | ) | `[inline]`

CullingSet& osg::CullingSet::operator= | ( | const CullingSet & | cs | ) | `[inline]`

float osg::CullingSet::pixelSize | ( | const BoundingSphere & | bs | ) | const`[inline]`

| Compute the pixel of a bounding sphere.

float osg::CullingSet::pixelSize | ( | const Vec3 & | v,
|  | float | radius
| ) | const`[inline]`

| Compute the pixel of an object at position v, with specified radius.

void osg::CullingSet::popCurrentMask | ( |  | ) | `[inline]`

void CullingSet::popOccludersCurrentMask | ( | NodePath & | nodePath | ) |

void osg::CullingSet::pushCurrentMask | ( |  | ) | `[inline]`

void osg::CullingSet::set | ( | const CullingSet & | cs,
|  | const Matrix & | matrix,
|  | const Vec4 & | pixelSizeVector
| ) | `[inline]`

void osg::CullingSet::set | ( | const CullingSet & | cs | ) | `[inline]`

void osg::CullingSet::setCullingMask | ( | Mask | mask | ) | `[inline]`

void osg::CullingSet::setFrustum | ( | Polytope & | cv | ) | `[inline]`

void osg::CullingSet::setPixelSizeVector | ( | const Vec4 & | v | ) | `[inline]`

void osg::CullingSet::setSmallFeatureCullingPixelSize | ( | float | value | ) | `[inline]`

## Member Data Documentation

Polytope osg::CullingSet::_frustum`[protected]`

Mask osg::CullingSet::_mask`[protected]`

OccluderList osg::CullingSet::_occluderList`[protected]`

Vec4 osg::CullingSet::_pixelSizeVector`[protected]`

float osg::CullingSet::_smallFeatureCullingPixelSize`[protected]`

The documentation for this class was generated from the following files:

- CullingSet
- CullingSet.cpp